#ifndef EXAMPLETARGETLINE_H
#define EXAMPLETARGETLINE_H

#include "TargetLine.h"

/**
 * Example implementation of a target line
 */
class ExampleTargetLine : public TargetLine
{
public:
	ExampleTargetLine(const char name[]);
	~ExampleTargetLine();
	DEV_ERR_CODE Open();
	DEV_ERR_CODE Close();
	DEV_ERR_CODE Start();
	DEV_ERR_CODE Stop();
	DEV_ERR_CODE Write(char bytes[], uint32 numBytes, bool8 isSigned, uint32 *numWritten);
	DEV_ERR_CODE GetNumBytesWritable(uint32 *numWritable);
	DEV_ERR_CODE GetNumBytesBuffer(uint32 *numBytes);
	bool8 IsOpen();
	bool8 IsStarted();
	uint32 GetSampleRateHz();
	uint32 GetNumChannels();
	uint32 GetNumBytesPerSample();
	void GetName(char name[], uint32 numChars, uint32 *numCharsRequired);

private:
	const char *name;
	bool8 isStarted;
	bool8 isOpen;
	uint32 numBytesWritable;
};

#endif