#include "ExampleSourceLine.h"
#include "error_codes.h"
#include "string.h"

static const uint32 NUM_CHANNELS = 2;
static const uint32 SAMPLE_RATE_HZ = 48000;
static const uint32 NUM_BYTES_PER_SAMPLE = 3;

ExampleSourceLine::ExampleSourceLine(const char *name)
{
	this->name = name;
	this->isOpen = FALSE;
	this->isStarted = FALSE;
	this->numBytesReadable = 0;
}
ExampleSourceLine::~ExampleSourceLine()
{
}

DEV_ERR_CODE ExampleSourceLine::Open()
{
	// PUT YOUR CODE HERE
	isOpen = TRUE;
	return NO_ERROR;
}
DEV_ERR_CODE ExampleSourceLine::Close()
{
	// PUT YOUR CODE HERE
	isOpen = FALSE;
	return NO_ERROR;
}

DEV_ERR_CODE ExampleSourceLine::Start()
{
	// PUT YOUR CODE HERE
	isStarted = TRUE;
	return NO_ERROR;
}

DEV_ERR_CODE ExampleSourceLine::Stop()
{
	// PUT YOUR CODE HERE
	isStarted = FALSE;
	return NO_ERROR;
}

DEV_ERR_CODE ExampleSourceLine::GetNumBytesReadable(uint32 *numReadable)
{
	if (!IsOpen())
	{
		return DEVICE_NOT_OPENED;
	}
	// PUT YOUR CODE HERE

	// EXAMPLE:
	*numReadable = this->numBytesReadable;
	this->numBytesReadable += 10000;
	uint32 numBuffer;
	GetNumBytesBuffer(&numBuffer);
	if (this->numBytesReadable > numBuffer)
	{
		this->numBytesReadable = numBuffer;
	}
	return NO_ERROR;
}

DEV_ERR_CODE ExampleSourceLine::Read(char bytes[], uint32 numBytes, bool8 isSigned, uint32 *numRead)
{
	if (!IsOpen())
	{
		return DEVICE_NOT_OPENED;
	}
	if (!IsStarted())
	{
		return DEVICE_NOT_STARTED;
	}

	// PUT YOUR CODE HERE

	// EXAMPLE:
	if (this->numBytesReadable >= numBytes)
	{
		*numRead = numBytes;
		this->numBytesReadable -= numBytes;
	}
	else
	{
		*numRead = 0;
	}
	return NO_ERROR;
}

DEV_ERR_CODE ExampleSourceLine::GetNumBytesBuffer(uint32 *numBytes)
{
	if (!IsOpen())
	{
		return DEVICE_NOT_OPENED;
	}
	// PUT YOUR CODE HERE

	// EXAMPLE:
	*numBytes = 100000;
	return NO_ERROR;
}

uint32 ExampleSourceLine::GetSampleRateHz()
{
	return SAMPLE_RATE_HZ;
}

uint32 ExampleSourceLine::GetNumChannels()
{
	return NUM_CHANNELS;
}

bool8 ExampleSourceLine::IsOpen()
{
	return isOpen;
}

bool8 ExampleSourceLine::IsStarted()
{
	return isStarted;
}

uint32 ExampleSourceLine::GetNumBytesPerSample()
{
	return NUM_BYTES_PER_SAMPLE;
}

void ExampleSourceLine::GetName(char name[], uint32 numChars, uint32 *numCharsRequired)
{
	*numCharsRequired = (uint32)strlen(this->name)+1; // +1 Add zero delimiter '\0'
	if (numChars > *numCharsRequired)
	{
		numChars = *numCharsRequired;
	}
	strncpy(name, this->name, numChars);
}
